RabbitMQ `3.9.29` is a maintenance release in the `3.9.x` release series.

This series [**reaches end of general support** on Jan 31st, 2023](https://rabbitmq.com/versions.html).

Please refer to the **Upgrading to 3.9** section from [v3.9.0 release notes](https://github.com/rabbitmq/rabbitmq-server/releases/tag/v3.9.0)
if upgrading from a version prior to 3.9.0.

This release requires at least Erlang 24.3, and supports Erlang 25.
[RabbitMQ and Erlang/OTP Compatibility Matrix](https://www.rabbitmq.com/which-erlang.html) has more details on Erlang version requirements for RabbitMQ.


### Minimum Supported Erlang Version

Erlang 23 support has reached its [end of support](https://www.rabbitmq.com/which-erlang.html).

Starting with this release, RabbitMQ requires Erlang 24.3 or later versions. Nodes **will fail to start** on older Erlang releases.

## Changes Worth Mentioning

Release notes can be found on GitHub at [rabbitmq-server/release-notes](https://github.com/rabbitmq/rabbitmq-server/tree/v3.9.x/release-notes).


### CLI Tools

#### Enhancements

 * CLI tools will now report this version as [no longer supported](https://rabbitmq.com/versions.html)
   in `rabbitmq-diagnostics status` output.


### LDAP Plugin

#### Bug Fixes

 * Due to a `$` sign escaping differences between Make and Bazel (the newly adopted build tool),
   default value of of `user_dn_pattern` setting was incorrect (had an extra `$`).

   GitHub issue: [#7161](https://github.com/rabbitmq/rabbitmq-server/issues/7161)


## Dependency Upgrades

None in this release.


## Source Code Archives

To obtain source code of the entire distribution, please download the archive named `rabbitmq-server-3.9.29.tar.xz`
instead of the source tarball produced by GitHub.
